<template>
  <el-dialog
    :title="!dataForm.id ? '新增' : '修改'"
    :close-on-click-modal="false"
    :visible.sync="visible">
    <el-form :model="dataForm" :rules="dataRule" ref="dataForm" @keyup.enter.native="dataFormSubmit()"
             label-width="80px">
      <el-form-item label="案件：" prop="name">
        <el-select v-model="dataForm.administrativePenaltyFilesId" placeholder="请选择" @change="causeChange">
          <el-option
            v-for="item in processAjApprovalList"
            :key="item.id"
            :label="item.processAjCoverName"
            :value="item.id+''">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="住址或地址" prop="address">
        <el-input v-model="dataForm.address" placeholder="住址或地址"></el-input>
      </el-form-item>
      <el-form-item label="委托代理人" prop="agent">
        <el-input v-model="dataForm.agent" placeholder="委托代理人"></el-input>
      </el-form-item>
      <el-form-item label="委托代理人住址或地址" prop="agentAddress">
        <el-input v-model="dataForm.agentAddress" placeholder="委托代理人住址或地址"></el-input>
      </el-form-item>
      <el-form-item label="委托代理人身份证号" prop="agentIdCard">
        <el-input v-model="dataForm.agentIdCard" placeholder="委托代理人身份证号"></el-input>
      </el-form-item>
      <el-form-item label="委托代理人联系电话" prop="agentPhone">
        <el-input v-model="dataForm.agentPhone" placeholder="委托代理人联系电话"></el-input>
      </el-form-item>
      <el-form-item label="委托代理人工作单位及职务" prop="agentWorkAndPosition">
        <el-input v-model="dataForm.agentWorkAndPosition" placeholder="委托代理人工作单位及职务"></el-input>
      </el-form-item>
      <el-form-item label="简要案情" prop="briefCase">
        <el-input v-model="dataForm.briefCase" placeholder="简要案情"></el-input>
      </el-form-item>
      <el-form-item label="案由" prop="causeAction">
        <el-input v-model="dataForm.causeAction" placeholder="案由"></el-input>
      </el-form-item>
      <el-form-item label="立案时间" prop="filingTime">
<!--        <el-input v-model="dataForm.filingTime" placeholder="立案时间"></el-input>-->
        <el-date-picker
          style="width: 100%"
          value-format="yyyy-MM-dd"
          v-model="dataForm.filingTime"
          type="date"
          placeholder="选择日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="处理意见和建议" prop="handlingOpinionsAndSuggestions">
        <el-input v-model="dataForm.handlingOpinionsAndSuggestions" placeholder="处理意见和建议"></el-input>
      </el-form-item>
      <el-form-item label="身份证号" prop="idCard">
        <el-input v-model="dataForm.idCard" placeholder="身份证号"></el-input>
      </el-form-item>
      <el-form-item label="调查经过" prop="investigationProcess">
        <el-input v-model="dataForm.investigationProcess" placeholder="调查经过"></el-input>
      </el-form-item>
      <el-form-item label="执法证号" prop="lawEnforcementCertificateNo">
        <el-input v-model="dataForm.lawEnforcementCertificateNo" placeholder="执法证号"></el-input>
      </el-form-item>
      <el-form-item label="执法人员" prop="lawEnforcementOfficials">
        <el-input v-model="dataForm.lawEnforcementOfficials" placeholder="执法人员"></el-input>
      </el-form-item>
      <el-form-item label="法定代表人" prop="legalRepresentative">
        <el-input v-model="dataForm.legalRepresentative" placeholder="法定代表人"></el-input>
      </el-form-item>
      <el-form-item label="当事人" prop="party">
        <el-input v-model="dataForm.party" placeholder="当事人"></el-input>
      </el-form-item>
      <el-form-item label="联系电话" prop="phone">
        <el-input v-model="dataForm.phone" placeholder="联系电话"></el-input>
      </el-form-item>
      <el-form-item label="承办人签名" prop="signatureOfTheUndertaker">
        <el-input v-model="dataForm.signatureOfTheUndertaker" placeholder="承办人签名"></el-input>
      </el-form-item>
      <el-form-item label="案件来源" prop="source">
        <el-input v-model="dataForm.source" placeholder="案件来源"></el-input>
      </el-form-item>
      <el-form-item label="工作单位及职务" prop="workAndPosition">
        <el-input v-model="dataForm.workAndPosition" placeholder="工作单位及职务"></el-input>
      </el-form-item>
    </el-form>
    <span slot="footer" class="dialog-footer">
      <el-button @click="visible = false">取消</el-button>
      <el-button type="primary" @click="dataFormSubmit()">确定</el-button>
    </span>
  </el-dialog>
</template>

<script>
import {getObj, addObj, putObj} from '@/api/process/finalreportofinvestigation'
import {findAll} from "@/api/process/processajapproval";

export default {
  data() {
    return {
      visible: false,
      processAjApprovalList: [],
      dataForm: {
        id: 0,
        createBy: '',
        createTime: '',
        updateBy: '',
        updateTime: '',
        address: '',
        agent: '',
        agentAddress: '',
        agentIdCard: '',
        agentPhone: '',
        agentWorkAndPosition: '',
        briefCase: '',
        causeAction: '',
        filingTime: '',
        handlingOpinionsAndSuggestions: '',
        idCard: '',
        investigationProcess: '',
        lawEnforcementCertificateNo: '',
        lawEnforcementOfficials: '',
        legalRepresentative: '',
        party: '',
        phone: '',
        signatureOfTheUndertaker: '',
        source: '',
        workAndPosition: ''
      },
      dataRule: {
        createBy: [
          {required: true, message: '不能为空', trigger: 'blur'}
        ],
        createTime: [
          {required: true, message: '不能为空', trigger: 'blur'}
        ],
        delFlag: [
          {required: true, message: '不能为空', trigger: 'blur'}
        ],
        updateBy: [
          {required: true, message: '不能为空', trigger: 'blur'}
        ],
        updateTime: [
          {required: true, message: '不能为空', trigger: 'blur'}
        ],
        address: [
          {required: true, message: '住址或地址不能为空', trigger: 'blur'}
        ],
        agent: [
          {required: true, message: '委托代理人不能为空', trigger: 'blur'}
        ],
        agentAddress: [
          {required: true, message: '委托代理人住址或地址不能为空', trigger: 'blur'}
        ],
        agentIdCard: [
          {required: true, message: '委托代理人身份证号不能为空', trigger: 'blur'}
        ],
        agentPhone: [
          {required: true, message: '委托代理人联系电话不能为空', trigger: 'blur'}
        ],
        agentWorkAndPosition: [
          {required: true, message: '委托代理人工作单位及职务不能为空', trigger: 'blur'}
        ],
        briefCase: [
          {required: true, message: '简要案情不能为空', trigger: 'blur'}
        ],
        causeAction: [
          {required: true, message: '案由不能为空', trigger: 'blur'}
        ],
        filingTime: [
          {required: true, message: '立案时间不能为空', trigger: 'blur'}
        ],
        handlingOpinionsAndSuggestions: [
          {required: true, message: '处理意见和建议不能为空', trigger: 'blur'}
        ],
        idCard: [
          {required: true, message: '身份证号不能为空', trigger: 'blur'}
        ],
        investigationProcess: [
          {required: true, message: '调查经过不能为空', trigger: 'blur'}
        ],
        lawEnforcementCertificateNo: [
          {required: true, message: '执法证号不能为空', trigger: 'blur'}
        ],
        lawEnforcementOfficials: [
          {required: true, message: '执法人员不能为空', trigger: 'blur'}
        ],
        legalRepresentative: [
          {required: true, message: '法定代表人不能为空', trigger: 'blur'}
        ],
        party: [
          {required: true, message: '当事人不能为空', trigger: 'blur'}
        ],
        phone: [
          {required: true, message: '联系电话不能为空', trigger: 'blur'}
        ],
        signatureOfTheUndertaker: [
          {required: true, message: '承办人签名不能为空', trigger: 'blur'}
        ],
        source: [
          {required: true, message: '案件来源不能为空', trigger: 'blur'}
        ],
        workAndPosition: [
          {required: true, message: '工作单位及职务不能为空', trigger: 'blur'}
        ]
      }
    }
  },
  methods: {
    init(id) {
      this.dataForm.id = id || 0
      this.visible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].resetFields()
        if (this.dataForm.id) {
          getObj(this.dataForm.id).then(response => {
            this.dataForm = response.data.data
          })
        }
      })
      this.findAllProcessAj();
    },
    //查询所有案件
    findAllProcessAj() {
      findAll().then(res => {
        this.processAjApprovalList = res.data.data
      });
    },
    causeChange(id) {
      let processAjApproval;
      this.processAjApprovalList.forEach(item => {
        if(item.id === id){
          processAjApproval = item;
        }
      });
      this.dataForm.administrativePenaltyFilesId = id;
      this.dataForm.processAjApprovalId = id;
      this.dataForm.causeAction = processAjApproval.caseReason;
      this.dataForm.caseAndInvestigation = processAjApproval.caseReason;
    },
    // 表单提交
    dataFormSubmit() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          if (this.dataForm.id) {
            putObj(this.dataForm).then(data => {
              this.$message.success('修改成功')
              this.visible = false
              this.$emit('refreshDataList')
            });
          } else {
            addObj(this.dataForm).then(data => {
              this.$message.success('添加成功')
              this.visible = false
              this.$emit('refreshDataList')
            })
          }
        }
      })
    }
  }
}
</script>
